Everything in js happens inside an execution context.
execiton context is like a box or a container

two parts: memory(variable enviornment):key value pairs ,variables functions| code component(thred of execution)

Js is a single threaded , sync language.
js can execute one command at a time in a specif order.

The execution context is created in two phases
1. memory creation phase.
allocates memory
variable:undef
func:references
2. code exection phase.
Js runs through the whole code again.
variable: actual value
function: BRand new execution context is created
once function return the exec context will be deleted.
one whole program has run the exec context is deleted.

how does the js manages all the exec context and control?
it has its own call stack.
GEC is pushed in stack it has its own control.
New EC is pushed on top of the stack it has the control when it has done all its work it is popped.

Call stack is only for managing EC



Hoisting in JS: accesing variales before declarations/initilazion.

if we wirte arrow syntax it will be undefined and if we write normal function it will the function itself.


When js runs a window obj is created 
and this is th window obj


global space is anything in js that you dont write in a function

scope means where you can access a specific variable in our code.

whereever a global env is created a lexical env is also created.
lexical env is its own local memory and the memory of its parent.
lexicall means sequence or in order
scope chain is chain of lexical env and their parents.

var is stored in the global object 
and const and let are stored in a different memory space and you cannot acces this memory space unless you declare them.

TDZ is the time period when a variable is hoisted until it is given some value.

A block is a combined statedment or {}


function along with its lexical scope forms a closure.

A closure is the combination of a function bundled together (enclosed) with references to its surrounding state (the lexical environment). In other words, a closure gives you access to an outer function's scope from an inner function. In JavaScript, closures are created every time a function is created, at function creation time.